import mariadb from 'mariadb'

let conn : mariadb.Connection


class DbHandle {
    private _conn? : mariadb.Connection

    public constructor() {}

    public async connect() : Promise<void> {
        this._conn = await mariadb.createConnection({
            host: '172.16.10.18',
            user: 'heroes',
            password: 'test123',
            database: 'heroes'
        })
    }

    public get(stmt : string) : Promise<any> {
        return this._conn?.query(stmt) ?? Promise.reject(new Error('Connection not ready 1'))
    }

    public close() : Promise<void> {
        return this._conn?.end() ?? Promise.reject(new Error('Connection not ready 2'))
    }
}



/*
const dbHandle = new DbHandle()
dbHandle.connect()
    .then(() => dbHandle.get("SELECT * FROM hero"))
    .then((result) => { 
        console.log(result)
        return dbHandle.close() 
    })
    .catch((err) => {
        console.log(err)
    })
*/

async function exec() : Promise<void> {
    const dbHandle = new DbHandle()
    await dbHandle.connect()
    const result = await dbHandle.get("SELECT * FROM hero")
    console.log(result)
    await dbHandle.close()
}

exec().catch((err) => console.log(err.message))

/*
dbHandle.get("SELECT * FROM hero")
    .then((result) => { 
        console.log(result)
        return dbHandle.close() 
    })
    .catch((err) => {
        console.log(err.message)
    })
*/